// Include CImg library file and use its main namespace
#include "CImg.h"
#include <iostream>
using namespace cimg_library;

int main(int argc,char **argv) {
  
  // Display program usage, when invoked from the command line with option '-h'.
  cimg_usage("Read an image, dump rgb values for each pixels, and save the image in bmp ");
  // Program options
  const char* file_i = cimg_option("-i","../../Images/lena.jpg","Input image");
  const char* file_o = cimg_option("-o","../../Images/lena.bmp","Output image");
  
  // Load an image
  CImg<unsigned char> image =  CImg<>(file_i);
  
  // Create a display window
  CImgDisplay main_disp(image,"Input Image");
   
  // Enter event loop. This loop ends when the display window is closed or when the keys 'ESC' or 'Q' are pressed.
  while (!main_disp.is_closed &&
	 !main_disp.is_keyESC && 
	 !main_disp.is_keyQ) {
    cimg::wait(20);
  }
  
  // Navigate pixels
  // for (int y=0 ; y<myImage.dimx() ; y++){
  //       for (int x=0 ; x<myImage.dimy() ; x++){
  //               ...
  //       }
  // }
  cimg_forXY(image,x,y){
    std::cout << "[ "<< (float)image(x,y,0) << "," << (float)image(x,y,1) << "," << (float)image(x,y,2) << "]"<< std::endl;
  }
  
  // Save the image
  image.save_bmp(file_o);
  
  return 0;
}
