/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.cnrs.i3s.tdimageio.solution;

import java.awt.Color;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;

/**
 *
 * @author gaignard
 */
public class ImageReaderWriter {

    public BufferedImage load(String filePath) {
        File fileSelected = new File(filePath);
        BufferedImage bi = null;
        try {
            bi = ImageIO.read(fileSelected);

        } catch (IOException e) {
            System.out.println(e.getStackTrace());
        }
        return bi;
    }

    public void histogram(BufferedImage bi) {
        int[] rHist = new int[256];

        //Populates the histogram
        int w = bi.getWidth();
        int h = bi.getHeight();
        for (int i = 0; i < w; i++) {
            for (int j = 0; j < h; j++) {
                Color c = new Color(bi.getRGB(i, j));
                rHist[c.getRed()]++;
            }
        }

        //Computes the max of the histogram
        double rMax = 0.0;
        for (int i = 0; i < rHist.length; i++) {
            if (rHist[i] > rMax) {
                rMax = rHist[i];
            }
        }

        //Normalizes the histogram
        int maxNorm = 20;
        long[] rHistNorm = new long[256];
        for (int i = 0; i < rHist.length; i++) {
            double n = rHist[i] * (maxNorm / rMax);
            rHistNorm[i] = Math.round(n);
        }

        //Prints the histogram
        for (int i = maxNorm; i >= 0; i--) {
            String s = "";
            for (int j = 0; j < rHistNorm.length; j++) {
                if (rHistNorm[j] == i) {
                    s += "+";
                } else {
                    s += " ";
                }
            }
            System.out.println(s);
        }
        System.out.println("");
    }

    public void dump(BufferedImage bi) {
        int w = bi.getWidth();
        int h = bi.getHeight();
        int cpt = 0;
        for (int i = 0; i < w; i++) {
            for (int j = 0; j < h; j++) {
                if ((cpt % 10) == 0) {
                    Color c = new Color(bi.getRGB(i, j));
                    System.out.println("[" + i + "," + j + "] = [" + c.getRed() + "," + c.getGreen() + "," + c.getBlue() + "]");
                }
                cpt++;
            }
        }
    }

    public void save(BufferedImage bi, String format, String filePath) {
        try {
            File outFile = new File(filePath);
            ImageIO.write(bi, format, outFile);
        } catch (IOException e) {
            System.out.println(e.getStackTrace());
        }
    }

    public static void main(String[] args) {
        ImageReaderWriter rw = new ImageReaderWriter();
//        BufferedImage img = rw.load("/Users/gaignard/Documents/Teaching-Formation/TD-Image-2013/Sujet/High-key.jpg");
//        BufferedImage img = rw.load("/Users/gaignard/Google Drive/Photo/MacaoHongkong-2012/_DSC7383_126.jpg");
        BufferedImage img = rw.load("../../Images/lena.jpg");
//        rw.dump(img);
        rw.histogram(img);
        rw.save(img, "bmp", "../../Images/lena.bmp");
    }
}
